Name "Apprenticlavier"

; Nom du fichier compil qui sera excut
OutFile "ApC110_AZERTY-FR_FRA_inst.exe"

; Evite la fentre d'ouverture de nsis (Silent Uninstall ncessaire si Silent Install utilis !)
SilentInstall silent
SilentUnInstall silent


; ****************** DECHARGEMENT ************************************************
Section "" 

; Dcharger tous les fichiers de base dans un rpertoire temporaire
setoutpath "c:\temp\apcz"
file ApprentiClavier.exe
file ApprentiClavier.jcf
file ApprentiClavier.jdf
file ApprentiClavier.jsb
file ApprentiClavier-Jaws401.jsb
file ApprentiClavier.jss

; Dcharger aussi les fichiers complmentaires
file *.txt
file *.wav

; Dcharger le fichier d'installation/dsinstallation et la dll pour Visual Basic 4, dans le rpertoire temporaire et dans le rpertoire windows
file ApprentiClavier_Setup.exe
file VB40032.dll
setoutpath "$WINDIR"
file ApprentiClavier_Setup.exe
file VB40032.dll

; Copier les leons personnalises jointes  l'excutable d'installation
call CopyTxt

SectionEnd


; ************ SI SUCCES du DECHARGEMENT ***********************************
Function .onInstSuccess

; Lancer ApprentiClavier_Setup.exe
ExecWait "c:\temp\apcz\ApprentiClavier_Setup.exe"

; Selon le choix utilisateur ou le succs de l'installation !
IfFileExists "c:\ApprentiClavier\ApprentiClavier.exe" Y1 Y2

Y1:
; Prvoir les cls de dsinstallation pour Windows (NE PAS PRECISER LA VERSION)
WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ApprentiClavier" "DisplayName" "ApprentiClavier"
WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ApprentiClavier" "UninstallString" "$WINDIR\ApprentiClavier_uninstall.exe"
WriteRegDword HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ApprentiClavier" "NoModify" "1"

; Ecrire le fichier de dsinstallation
WriteUninstaller "$WINDIR\ApprentiClavier_uninstall.exe"

; Inscrire dans le menu Dmarrer
CreateDirectory "$SMPROGRAMS\ApprentiClavier"
CreateShortCut "$SMPROGRAMS\ApprentiClavier\ApprentiClavier.lnk" "c:\ApprentiClavier\ApprentiClavier.exe" "" "" 0
CreateShortCut "$SMPROGRAMS\ApprentiClavier\Dsinstaller ApprentiClavier.lnk" "$WINDIR\ApprentiClavier_uninstall.exe" "" "" 0
CreateShortCut "$SMPROGRAMS\ApprentiClavier\Informations gnrales.lnk" "c:\ApprentiClavier\alire.txt" "" "" 0
CreateShortCut "$SMPROGRAMS\ApprentiClavier\Informations sur la sonorisation.lnk" "c:\ApprentiClavier\sonorisation.txt" "" "" 0
CreateShortCut "$SMPROGRAMS\ApprentiClavier\Informations pour les enseignants.lnk" "c:\ApprentiClavier\leons\Personnalis\info.txt" "" "" 0

; Inscrire une icne dans le bureau (Mettre Espace entre Apprenti et Clavier)
Delete "$DESKTOP\ApprentiClavier.lnk"
CreateShortCut "$DESKTOP\Apprenti Clavier.lnk" "c:\ApprentiClavier\ApprentiClavier.exe" "" "$WINDIR\notepad.exe" 0
goto Y3

Y2:
; Installation rate ou dsinstallation demande, relancer le mme ex avec option /D Quiet
ExecWait '"c:\temp\apcz\ApprentiClavier_setup.exe" /DQ'

; Supprimer les cls du registre
DeleteRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ApprentiClavier"

; Supprimer les shortcuts
Delete "$SMPROGRAMS\ApprentiClavier\*.*"
rmdir "$SMPROGRAMS\ApprentiClavier"

; Supprimer l'icne du bureau
Delete "$DESKTOP\ApprentiClavier.lnk"
Delete "$DESKTOP\Apprenti Clavier.lnk"

; Supprimer les fichiers rsiduels
rmdir /r "c:\ApprentiClavier"

; Supprimer les excutables d'installation/dsinstallation
Delete "$WINDIR\ApprentiClavier_setup.exe"
Delete "$WINDIR\ApprentiClavier_uninstall.exe"
Delete "$WINDIR\VB40032.dll"

Y3:
; Message final
;messagebox MB_OK|MB_TOPMOST "FIN DE L'INSTALLATION. AU REVOIR"

; Supprimer le dchargement temporaire
rmdir /r "c:\temp\apcz"
FunctionEnd


; *************************************************************************
Function CopyTxt

; Dcharger/Copier les leons personnalises jointes  l'excutable d'installation
createdirectory "c:\temp\apcz\perso"
IfFileExists "$EXEDIR\leon1A.txt" A1 VB1
A1:
copyfiles "$EXEDIR\leon1A.txt" "c:\temp\apcz\perso\leon1A.txt"
VB1:
IfFileExists "$EXEDIR\leon1B.txt" B1 VC1
B1:
copyfiles "$EXEDIR\leon1B.txt" "c:\temp\apcz\perso\leon1B.txt"
VC1:
IfFileExists "$EXEDIR\leon1C.txt" C1 VA2
C1:
copyfiles "$EXEDIR\leon1C.txt" "c:\temp\apcz\perso\leon1C.txt"
VA2:
IfFileExists "$EXEDIR\leon2A.txt" A2 VB2
A2:
copyfiles "$EXEDIR\leon2A.txt" "c:\temp\apcz\perso\leon2A.txt"
VB2:
IfFileExists "$EXEDIR\leon2B.txt" B2 VC2
B2:
copyfiles "$EXEDIR\leon2B.txt" "c:\temp\apcz\perso\leon2B.txt"
VC2:
IfFileExists "$EXEDIR\leon2C.txt" C2 VD2
C2:
copyfiles "$EXEDIR\leon2C.txt" "c:\temp\apcz\perso\leon2C.txt"
VD2:
IfFileExists "$EXEDIR\leon2D.txt" D2 VE2
D2:
copyfiles "$EXEDIR\leon2D.txt" "c:\temp\apcz\perso\leon2D.txt"
VE2:
IfFileExists "$EXEDIR\leon2E.txt" E2 VF2
E2:
copyfiles "$EXEDIR\leon2E.txt" "c:\temp\apcz\perso\leon2E.txt"
VF2:
IfFileExists "$EXEDIR\leon2F.txt" F2 VG2
F2:
copyfiles "$EXEDIR\leon2F.txt" "c:\temp\apcz\perso\leon2F.txt"
VG2:
IfFileExists "$EXEDIR\leon2G.txt" G2 VH2
G2:
copyfiles "$EXEDIR\leon2G.txt" "c:\temp\apcz\perso\leon2G.txt"
VH2:
IfFileExists "$EXEDIR\leon2H.txt" H2 VA3
H2:
copyfiles "$EXEDIR\leon2H.txt" "c:\temp\apcz\perso\leon2H.txt"
VA3:
IfFileExists "$EXEDIR\leon3A.txt" A3 VB3
A3:
copyfiles "$EXEDIR\leon3A.txt" "c:\temp\apcz\perso\leon3A.txt"
VB3:
IfFileExists "$EXEDIR\leon3B.txt" B3 VC3
B3:
copyfiles "$EXEDIR\leon3B.txt" "c:\temp\apcz\perso\leon3B.txt"
VC3:
IfFileExists "$EXEDIR\leon3C.txt" C3 VA4
C3:
copyfiles "$EXEDIR\leon3C.txt" "c:\temp\apcz\perso\leon3C.txt"
VA4:
IfFileExists "$EXEDIR\leon4A.txt" A4 VB4
A4:
copyfiles "$EXEDIR\leon4A.txt" "c:\temp\apcz\perso\leon4A.txt"
VB4:
IfFileExists "$EXEDIR\leon4B.txt" B4 VC4
B4:
copyfiles "$EXEDIR\leon4B.txt" "c:\temp\apcz\perso\leon4B.txt"
VC4:
IfFileExists "$EXEDIR\leon4C.txt" C4 VD4
C4:
copyfiles "$EXEDIR\leon4C.txt" "c:\temp\apcz\perso\leon4C.txt"
VD4:
IfFileExists "$EXEDIR\leon4D.txt" D4 VE4
D4:
copyfiles "$EXEDIR\leon4D.txt" "c:\temp\apcz\perso\leon4D.txt"
VE4:
IfFileExists "$EXEDIR\leon4E.txt" E4 VF4
E4:
copyfiles "$EXEDIR\leon4E.txt" "c:\temp\apcz\perso\leon4E.txt"
VF4:
IfFileExists "$EXEDIR\leon4F.txt" F4 VG4
F4:
copyfiles "$EXEDIR\leon4F.txt" "c:\temp\apcz\perso\leon4F.txt"
VG4:
IfFileExists "$EXEDIR\leon4G.txt" G4 VH4
G4:
copyfiles "$EXEDIR\leon4G.txt" "c:\temp\apcz\perso\leon4G.txt"
VH4:
IfFileExists "$EXEDIR\leon4H.txt" H4 VA5
H4:
copyfiles "$EXEDIR\leon4H.txt" "c:\temp\apcz\perso\leon4H.txt"
VA5:
IfFileExists "$EXEDIR\leon5A.txt" A5 VB5
A5:
copyfiles "$EXEDIR\leon5A.txt" "c:\temp\apcz\perso\leon5A.txt"
VB5:
IfFileExists "$EXEDIR\leon5B.txt" B5 VC5
B5:
copyfiles "$EXEDIR\leon5B.txt" "c:\temp\apcz\perso\leon5B.txt"
VC5:
IfFileExists "$EXEDIR\leon5C.txt" C5 VA6
C5:
copyfiles "$EXEDIR\leon5C.txt" "c:\temp\apcz\perso\leon5C.txt"
VA6:
IfFileExists "$EXEDIR\leon6A.txt" A6 VB6
A6:
copyfiles "$EXEDIR\leon6A.txt" "c:\temp\apcz\perso\leon6A.txt"
VB6:
IfFileExists "$EXEDIR\leon6B.txt" B6 VC6
B6:
copyfiles "$EXEDIR\leon6B.txt" "c:\temp\apcz\perso\leon6B.txt"
VC6:
IfFileExists "$EXEDIR\leon6C.txt" C6 VA7
C6:
copyfiles "$EXEDIR\leon6C.txt" "c:\temp\apcz\perso\leon6C.txt"
VA7:
IfFileExists "$EXEDIR\leon7A.txt" A7 VB7
A7:
copyfiles "$EXEDIR\leon7A.txt" "c:\temp\apcz\perso\leon7A.txt"
VB7:
IfFileExists "$EXEDIR\leon7B.txt" B7 VC7
B7:
copyfiles "$EXEDIR\leon7B.txt" "c:\temp\apcz\perso\leon7B.txt"
VC7:
IfFileExists "$EXEDIR\leon7C.txt" C7 VA8
C7:
copyfiles "$EXEDIR\leon7C.txt" "c:\temp\apcz\perso\leon7C.txt"
VA8:
IfFileExists "$EXEDIR\leon8A.txt" A8 VB8
A8:
copyfiles "$EXEDIR\leon8A.txt" "c:\temp\apcz\perso\leon8A.txt"
VB8:
IfFileExists "$EXEDIR\leon8B.txt" B8 VC8
B8:
copyfiles "$EXEDIR\leon8B.txt" "c:\temp\apcz\perso\leon8B.txt"
VC8:
IfFileExists "$EXEDIR\leon8C.txt" C8 VD8
C8:
copyfiles "$EXEDIR\leon8C.txt" "c:\temp\apcz\perso\leon8C.txt"
VD8:
IfFileExists "$EXEDIR\leon8D.txt" D8 VE8
D8:
copyfiles "$EXEDIR\leon8D.txt" "c:\temp\apcz\perso\leon8D.txt"
VE8:
IfFileExists "$EXEDIR\leon8E.txt" E8 VF8
E8:
copyfiles "$EXEDIR\leon8E.txt" "c:\temp\apcz\perso\leon8E.txt"
VF8:
IfFileExists "$EXEDIR\leon8F.txt" F8 VG8
F8:
copyfiles "$EXEDIR\leon8F.txt" "c:\temp\apcz\perso\leon8F.txt"
VG8:
IfFileExists "$EXEDIR\leon8G.txt" G8 VH8
G8:
copyfiles "$EXEDIR\leon8G.txt" "c:\temp\apcz\perso\leon8G.txt"
VH8:
IfFileExists "$EXEDIR\leon8H.txt" H8 VA9
H8:
copyfiles "$EXEDIR\leon8H.txt" "c:\temp\apcz\perso\leon8H.txt"
VA9:
IfFileExists "$EXEDIR\leon9A.txt" A9 VB9
A9:
copyfiles "$EXEDIR\leon9A.txt" "c:\temp\apcz\perso\leon9A.txt"
VB9:
IfFileExists "$EXEDIR\leon9B.txt" B9 VC9
B9:
copyfiles "$EXEDIR\leon9B.txt" "c:\temp\apcz\perso\leon9B.txt"
VC9:
IfFileExists "$EXEDIR\leon9C.txt" C9 VD9
C9:
copyfiles "$EXEDIR\leon9C.txt" "c:\temp\apcz\perso\leon9C.txt"
VD9:
IfFileExists "$EXEDIR\leon9D.txt" D9 VA10
D9:
copyfiles "$EXEDIR\leon9D.txt" "c:\temp\apcz\perso\leon9D.txt"
VA10:
IfFileExists "$EXEDIR\leon10A.txt" A10 VB10
A10:
copyfiles "$EXEDIR\leon10A.txt" "c:\temp\apcz\perso\leon10A.txt"
VB10:
IfFileExists "$EXEDIR\leon10B.txt" B10 VC10
B10:
copyfiles "$EXEDIR\leon10B.txt" "c:\temp\apcz\perso\leon10B.txt"
VC10:
IfFileExists "$EXEDIR\leon10C.txt" C10 VA11
C10:
copyfiles "$EXEDIR\leon10C.txt" "c:\temp\apcz\perso\leon10C.txt"
VA11:
IfFileExists "$EXEDIR\leon11A.txt" A11 VB11
A11:
copyfiles "$EXEDIR\leon11A.txt" "c:\temp\apcz\perso\leon11A.txt"
VB11:
IfFileExists "$EXEDIR\leon11B.txt" B11 VC11
B11:
copyfiles "$EXEDIR\leon11B.txt" "c:\temp\apcz\perso\leon11B.txt"
VC11:
IfFileExists "$EXEDIR\leon11C.txt" C11 VA12
C11:
copyfiles "$EXEDIR\leon11C.txt" "c:\temp\apcz\perso\leon11C.txt"
VA12:
IfFileExists "$EXEDIR\leon12A.txt" A12 VB12
A12:
copyfiles "$EXEDIR\leon12A.txt" "c:\temp\apcz\perso\leon12A.txt"
VB12:
IfFileExists "$EXEDIR\leon12B.txt" B12 VC12
B12:
copyfiles "$EXEDIR\leon12B.txt" "c:\temp\apcz\perso\leon12B.txt"
VC12:
IfFileExists "$EXEDIR\leon12C.txt" C12 VD12
C12:
copyfiles "$EXEDIR\leon12C.txt" "c:\temp\apcz\perso\leon12C.txt"
VD12:
IfFileExists "$EXEDIR\leon12D.txt" D12 VA13
D12:
copyfiles "$EXEDIR\leon12D.txt" "c:\temp\apcz\perso\leon12D.txt"
VA13:
IfFileExists "$EXEDIR\leon13A.txt" A13 VB13
A13:
copyfiles "$EXEDIR\leon13A.txt" "c:\temp\apcz\perso\leon13A.txt"
VB13:
IfFileExists "$EXEDIR\leon13B.txt" B13 VC13
B13:
copyfiles "$EXEDIR\leon13B.txt" "c:\temp\apcz\perso\leon13B.txt"
VC13:
IfFileExists "$EXEDIR\leon13C.txt" C13 VD13
C13:
copyfiles "$EXEDIR\leon13C.txt" "c:\temp\apcz\perso\leon13C.txt"
VD13:
IfFileExists "$EXEDIR\leon13D.txt" D13 VE13
D13:
copyfiles "$EXEDIR\leon13D.txt" "c:\temp\apcz\perso\leon13D.txt"
VE13:
IfFileExists "$EXEDIR\leon13E.txt" E13 VF13
E13:
copyfiles "$EXEDIR\leon13E.txt" "c:\temp\apcz\perso\leon13E.txt"
VF13:
IfFileExists "$EXEDIR\leon13F.txt" F13 VA14
F13:
copyfiles "$EXEDIR\leon13F.txt" "c:\temp\apcz\perso\leon13F.txt"
VA14:
IfFileExists "$EXEDIR\leon14A.txt" A14 VB14
A14:
copyfiles "$EXEDIR\leon14A.txt" "c:\temp\apcz\perso\leon14A.txt"
VB14:
IfFileExists "$EXEDIR\leon14B.txt" B14 VC14
B14:
copyfiles "$EXEDIR\leon14B.txt" "c:\temp\apcz\perso\leon14B.txt"
VC14:
IfFileExists "$EXEDIR\leon14C.txt" C14 VA15
C14:
copyfiles "$EXEDIR\leon14C.txt" "c:\temp\apcz\perso\leon14C.txt"
VA15:
IfFileExists "$EXEDIR\leon15A.txt" A15 VB15
A15:
copyfiles "$EXEDIR\leon15A.txt" "c:\temp\apcz\perso\leon15A.txt"
VB15:
IfFileExists "$EXEDIR\leon15B.txt" B15 VC15
B15:
copyfiles "$EXEDIR\leon15B.txt" "c:\temp\apcz\perso\leon15B.txt"
VC15:
IfFileExists "$EXEDIR\leon15C.txt" C15 VA16
C15:
copyfiles "$EXEDIR\leon15C.txt" "c:\temp\apcz\perso\leon15C.txt"
VA16:
IfFileExists "$EXEDIR\leon16A.txt" A16 VB16
A16:
copyfiles "$EXEDIR\leon16A.txt" "c:\temp\apcz\perso\leon16A.txt"
VB16:
IfFileExists "$EXEDIR\leon16B.txt" B16 VC16
B16:
copyfiles "$EXEDIR\leon16B.txt" "c:\temp\apcz\perso\leon16B.txt"
VC16:
IfFileExists "$EXEDIR\leon16C.txt" C16 VD16
C16:
copyfiles "$EXEDIR\leon16C.txt" "c:\temp\apcz\perso\leon16C.txt"
VD16:
IfFileExists "$EXEDIR\leon16D.txt" D16 VA17
D16:
copyfiles "$EXEDIR\leon16D.txt" "c:\temp\apcz\perso\leon16D.txt"
VA17:
IfFileExists "$EXEDIR\leon17A.txt" A17 VB17
A17:
copyfiles "$EXEDIR\leon17A.txt" "c:\temp\apcz\perso\leon17A.txt"
VB17:
IfFileExists "$EXEDIR\leon17B.txt" B17 VC17
B17:
copyfiles "$EXEDIR\leon17B.txt" "c:\temp\apcz\perso\leon17B.txt"
VC17:
IfFileExists "$EXEDIR\leon17C.txt" C17 VD17
C17:
copyfiles "$EXEDIR\leon17C.txt" "c:\temp\apcz\perso\leon17C.txt"
VD17:
IfFileExists "$EXEDIR\leon17D.txt" D17 VA18
D17:
copyfiles "$EXEDIR\leon17D.txt" "c:\temp\apcz\perso\leon17D.txt"
VA18:
IfFileExists "$EXEDIR\leon18A.txt" A18 VB18
A18:
copyfiles "$EXEDIR\leon18A.txt" "c:\temp\apcz\perso\leon18A.txt"
VB18:
IfFileExists "$EXEDIR\leon18B.txt" B18 VC18
B18:
copyfiles "$EXEDIR\leon18B.txt" "c:\temp\apcz\perso\leon18B.txt"
VC18:
IfFileExists "$EXEDIR\leon18C.txt" C18 VD18
C18:
copyfiles "$EXEDIR\leon18C.txt" "c:\temp\apcz\perso\leon18C.txt"
VD18:
IfFileExists "$EXEDIR\leon18D.txt" D18 VE18
D18:
copyfiles "$EXEDIR\leon18D.txt" "c:\temp\apcz\perso\leon18D.txt"
VE18:
IfFileExists "$EXEDIR\leon18E.txt" E18 VA19
E18:
copyfiles "$EXEDIR\leon18E.txt" "c:\temp\apcz\perso\leon18E.txt"
VA19:
IfFileExists "$EXEDIR\leon19A.txt" A19 VB19
A19:
copyfiles "$EXEDIR\leon19A.txt" "c:\temp\apcz\perso\leon19A.txt"
VB19:
IfFileExists "$EXEDIR\leon19B.txt" B19 VC19
B19:
copyfiles "$EXEDIR\leon19B.txt" "c:\temp\apcz\perso\leon19B.txt"
VC19:
IfFileExists "$EXEDIR\leon19C.txt" C19 VD19
C19:
copyfiles "$EXEDIR\leon19C.txt" "c:\temp\apcz\perso\leon19C.txt"
VD19:
IfFileExists "$EXEDIR\leon19D.txt" D19 VA20
D19:
copyfiles "$EXEDIR\leon19D.txt" "c:\temp\apcz\perso\leon19D.txt"
VA20:

FunctionEnd


; *************************************************************************
Section "Uninstall"

; Lancer l'excutable de dsinstallation
ExecWait '"$WINDIR\ApprentiClavier_setup.exe" /D'

; Selon le choix utilisateur, ou le succs de l'installation !
IfFileExists "c:\ApprentiClavier\ApprentiClavier.exe" Z2 Z1

Z1:
; Dsinstallation complte
; Supprimer les cls du registre
;messagebox MB_OK|MB_TOPMOST "Effacement des cls de la base de registres"
DeleteRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ApprentiClavier"

; Supprimer les shortcuts
Delete "$SMPROGRAMS\ApprentiClavier\*.*"
rmdir "$SMPROGRAMS\ApprentiClavier"

; Supprimer l'icne du bureau
Delete "$DESKTOP\ApprentiClavier.lnk"
Delete "$DESKTOP\Apprenti Clavier.lnk"

; Supprimer les fichiers rsiduels
rmdir /r "c:\ApprentiClavier"

; Supprimer les excutables d'installation/dsinstallation
Delete "$WINDIR\ApprentiClavier_setup.exe"
Delete "$WINDIR\ApprentiClavier_uninstall.exe"
Delete "$WINDIR\VB40032.dll"

Z2:
; Supprimer le dchargement temporaire
; rmdir /r "c:\temp\apcz"
SectionEnd